//////////////////////////////////////////////////////////////////////
// SSTVGen.h: interface for the SSTVGen class.
//
//////////////////////////////////////////////////////////////////////
//SoundCard/Wavefile signal generator program
// Copyright 1999.    Moe Wheatley AE4JY  <ae4jy@mindspring.com>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//////////////////////////////////////////////////////////////////////
//

#if !defined(AFX_SSTVGEN_H__ACB4CEA1_C356_11D2_88B9_444553540000__INCLUDED_)
#define AFX_SSTVGEN_H__ACB4CEA1_C356_11D2_88B9_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000



#define SSTV_S1_VIS_CODE 0x3C		//used to select Scottie 1 or Martin 1 modes
#define SSTV_M1_VIS_CODE 0xAC

#define SSTV_COLOR_PLANES 3
#define SSTV_TOTAL_LINES 256

class CSSTVGen  
{
public:
	CSSTVGen();
	virtual ~CSSTVGen();

// SSTV generator public functions
	void InitSSTV( BYTE vis, INT Fs , CDC* pDC);
	BOOL CalcSSTV( double* pData , INT n);

private:
// SSTV generator variables
	double m_SSTVSecPerPixel;
	BOOL m_Finished;
	double m_2PI;
	double m_SSTVSecPerSamp;
	double m_SSTVTime;
	INT m_SSTVLineCount;
	INT m_SSTVPixelCount;
	INT m_SSTVColorValue;
	double m_SSTVPhaseIncConst;
	double m_SSTVPhaseIncOffset;
	double m_SSTVPhaseInc;
	double m_SSTVNextEventTime;
	INT m_SSTVState;
	INT m_VISState;
	BYTE m_VISCode;
	BYTE m_SSTVMode;
	BYTE m_FrequencyCode;
	BYTE (*m_pImageArray)[SSTV_TOTAL_LINES][SSTV_COLOR_PLANES];

// SSTV generator private functions
	void DrawColorWedges(void);
	void ProcSSTVState( void );
	INT ProcVIS( void );
	INT ProcHsync( void );
	INT ProcRedPixels( void );
	INT ProcGrnPixels( void );
	INT ProcBluPixels( void );
	void DrawLine( INT x, INT y,INT width, COLORREF color, CDC* pDC );
	void CreateTestImage(CDC* pDC);

};

#endif // !defined(AFX_SSTVGEN_H__ACB4CEA1_C356_11D2_88B9_444553540000__INCLUDED_)
