// WSCGenDlg.h : header file
//
//SoundCard/Wavefile signal generator program
// Copyright 1999.    Moe Wheatley AE4JY  <ae4jy@mindspring.com>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WSCGENDLG_H__E8BE92C7_A478_11D2_B48C_444553540000__INCLUDED_)
#define AFX_WSCGENDLG_H__E8BE92C7_A478_11D2_B48C_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


#define SOUNDCARD_OUTPUT 0
#define WAVEFILE_OUTPUT 1

#define SIN_GEN 0
#define SSTV_GEN 1
#define PSK_GEN 2
#define BPSK_400A 3
#define BPSK_400B 4
#define MSK_GEN 5
#define MFSK_GEN 6
#define RTTY_GEN 7



/////////////////////////////////////////////////////////////////////////////
// CWSCGenDlg dialog

class CWSCGenDlg : public CDialog
{
// Construction
public:
	INT m_SweepRate;
	INT m_SweepRange;
	INT m_RMSOutput;
	double m_IMDGain;
	double GetIMD(){return m_IMD;};
	CWSCGenDlg(CWnd* pParent = NULL);	// standard constructor
	void ProcessAbort(void);

	UINT m_SampsPerSec;
	double m_NoiseAmplitude;
	double m_SignalAmplitude;
	CWinThread *m_pProcThread;
	CString m_PathName;
	INT m_RunningTime;
	CDC m_pDC;
// Dialog Data
	//{{AFX_DATA(CWSCGenDlg)
	enum { IDD = IDD_WSCGEN_DIALOG };
	CStatic	m_SweepRateCtrl;
	CStatic	m_SweepRangeCtrl;
	CButton	m_IdleOnlyCtrl;
	CButton	m_ReverseCtrl;
	CStatic	m_RMSCtrl;
	CEdit	m_IMDCtrl;
	CButton	m_FS8000Cntrl;
	CButton	m_FS9600Cntrl;
	CButton	m_FS11025Cntrl;
	CButton	m_FS22050Cntrl;
	CButton	m_FS44100Cntrl;
	CButton	m_FS48000Cntrl;
	CButton	m_BWLimitCntrl;
	CButton	m_S1Cntrl;
	CButton	m_M1Cntrl;
	CStatic	m_DiskSizeCntrl;
	CStatic	m_StatusCntrl;
	CButton	m_UseSoundcardCntrl;
	CButton	m_UseWaveFileCntrl;
	CButton	m_BPSKCntrl;
	CButton	m_QPSKCntrl;
	CButton	m_IQPSKCntrl;
	CButton	m_CWMODECntrl;
	CButton	m_SSTV2Source;
	CButton	m_PSK31Source;
	CButton  m_MSKSource;
	CButton  m_MFSKSource;
	CButton  m_RTTYSource;
	CButton  m_PSK400aSource;
	CButton  m_PSK400bSource;
	CButton	m_SinSource;
	CStatic	m_FileSizeCntrl;
	CStatic	m_FileNameCntrl;
	CButton	m_WaveSetupCntrl;
	CButton	m_StopButton;
	CButton	m_RunButton;
	CEdit	m_TimeLimitCntrl;
	CEdit	m_SNRCntrl;
	CEdit	m_SinFreqCntrl;
   BOOL  m_Reverse;
	BOOL	m_BWLimit;
	BOOL	m_PskIdleOnly;
	UINT	m_SinFreq;
	UINT	m_TimeLimit;
	int		m_SourceGroup;
	int		m_OutputGroup;
	int		m_PSKmode;
	int		m_SSTVMode;
	double	m_SNRatio;
	double	m_IMD;
	CString	m_FileName;
	CString	m_FileSize;
	int		m_SoundCardSelect;
	int		m_PskSpeedGrp;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWSCGenDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CWSCGenDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnRun();
	afx_msg void OnStop();
	afx_msg void OnAboutbox();
	virtual void OnOK();
	afx_msg void OnKillfocusSinfreq();
	afx_msg void OnKillfocusSnr();
	afx_msg void OnKillfocusTimelimit();
	afx_msg void OnSinewave();
	afx_msg void OnSstv();
	afx_msg void OnPsk31();
	afx_msg void OnRTTY();
	afx_msg void OnUsesoundcard();
	afx_msg void OnUsewavefile();
	afx_msg void OnWavesetup();
	virtual void OnCancel();
	afx_msg void OnDeltaposSnrspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnBwlimit();
	afx_msg void OnFs22050();
	afx_msg void OnFs44100();
	afx_msg void OnFs48000();
	afx_msg void OnFs11025();
	afx_msg void OnFs9600();
	afx_msg void OnFs8000();
	afx_msg void OnDeltaposFreqspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnKillfocusImd();
	afx_msg void OnDeltaposImdspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnPsk400a();
	afx_msg void OnPsk400b();
	afx_msg void OnMsk();
	afx_msg void OnMFSK();
	afx_msg void OnPskidleonly();
	afx_msg void OnDeltaposSweeprangespin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposSweepratespin(NMHDR* pNMHDR, LRESULT* pResult);
   afx_msg void OnReverse();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void UpdateSweepValues();
	BOOL ReadRegistrySettings(void);
	BOOL WriteRegistrySettings(void);
	void CalcIMD();
	UINT m_SinFreqLimit;
	INT m_StatusState;
	INT m_LastStatusState;
	BOOL m_FileSelected;
	UINT m_TimerID;
	LONGLONG m_FreeSpace;
	void UpdateFileStatus();
	void CalcSNR( void);
	void ChangeFrequency( void);
	void UpdateStatus(void);
public:
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WSCGENDLG_H__E8BE92C7_A478_11D2_B48C_444553540000__INCLUDED_)
